% Gnration d'une loi normale 1D
% de moyenne m et d'ecart type sigma
%m=3;
m=0;
%sigma=sqrt(5);
sigma=sqrt(1);
sigma2=sigma^2;
N=900;
Nc=15000;


% Metropolis Hastings Marche alatoire
% Loi de proposition uniforme sur [x-d ; x+d]
d=1;
% Initialisation
xMA=2*d*rand(N,1);
% matrice de sauvegarde
xsauve=zeros(N,Nc);

for j=1:Nc,
for i=1:N,
	% gnration 
 	inter=2*d*rand-d;
    y=xMA(i)+inter;
        % calcul de l'cart
	delta=((y-m)^2-(xMA(i)-m)^2)/(2*sigma2);
	% T=1 pour l'algorithme de Metropolis Hastings
	if (delta < 0.0 | exp(-delta)>rand)
		xMA(i)=y;
	end
end
xsauve(:,j)=xMA;
end

% affichage des resultats

% histogramme et loi cible - Metropolis Marche Alatoire
figure(1)
nh=100;
y=linspace(min(xsauve(:,Nc)),max(xsauve(:,Nc)),nh);
normal=(max(xsauve(:,Nc))-min(xsauve(:,Nc)))*N/nh;
plot(y,hist(xsauve(:,Nc),nh)/normal)
hold on
z = normpdf(y,m,sigma);
plot(y,z)
hold off

% calcul des moyennes et variances
figure(2)
for i=1:Nc
   moy(i)=mean(xsauve(1,1:i));
   variance(i)=var(xsauve(1,1:i));
end
plot(1:Nc,moy)
hold on

% Affichage histogrammes diffrentes valeurs de delta
% subplot(2,1,1)
% y=linspace(min(x1),max(x1),nh);
% normal=(max(x1)-min(x1))*N/nh;
% plot(y,hist(x1,nh)/normal)
% hold on
% z = normpdf(y,m,sigma);
% plot(y,z,'r')
% title('\delta = 1')
% hold off
% subplot(2,1,2),
% y=linspace(min(x001),max(x001),nh);
% normal=(max(x001)-min(x001))*N/nh;
% plot(y,hist(x001,nh)/normal)
% hold on
% z = normpdf(y,m,sigma);
% plot(y,z,'r')
% title('\delta = 0.01')
% hold off

% Affichage moyennes pour diffrentes valeurs de delta
% subplot(2,2,1)
% plot(1:Nc,moy01)
% hold on
% plot(1:Nc,zeros(1,Nc),'r')
% hold off
% title('\delta = 0.1')
% subplot(2,2,2)
% plot(1:Nc,moy05)
% hold on
% plot(1:Nc,zeros(1,Nc),'r')
% hold off
% title('\delta = 0.5')
% subplot(2,2,3)
% plot(1:Nc,moy1)
% hold on
% plot(1:Nc,zeros(1,Nc),'r')
% hold off
% title('\delta = 1')
% subplot(2,2,4)
% plot(1:Nc,moy5)
% hold on
% plot(1:Nc,zeros(1,Nc),'r')
% hold off
% title('\delta = 5')

% Affichage variances pour diffrentes valeurs de delta
% subplot(2,2,1)
% plot(1:Nc,var01)
% hold on
% plot(1:Nc,ones(1,Nc),'r')
% hold off
% title('\delta = 0.1')
% subplot(2,2,2)
% hold on
% plot(1:Nc,var05)
% hold on
% plot(1:Nc,ones(1,Nc),'r')
% hold off
% title('\delta = 0.5')
% subplot(2,2,3)
% plot(1:Nc,var1)
% hold on
% plot(1:Nc,ones(1,Nc),'r')
% hold off
% title('\delta = 1')
% subplot(2,2,4)
% plot(1:Nc,var5)
% hold on
% plot(1:Nc,ones(1,Nc),'r')
% hold off
% title('\delta = 5')